<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TIPregelGraphLibrary: src/standard/modules/algorithms/pregelSSSP.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIPregelGraphLibrary
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search", false, 'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Groups</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_3a3fb334f8e32f8b75f30f6eb3cfdf6e.html">src</a></li><li class="navelem"><a class="el" href="dir_41b3ccb19a6d365afc2b4a7bbd034095.html">standard</a></li><li class="navelem"><a class="el" href="dir_e5e605185631aa34c675c5c984a4ce63.html">modules</a></li><li class="navelem"><a class="el" href="dir_709bf4bcb4365c9d292f00f24fad6060.html">algorithms</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">pregelSSSP.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="pregelSSSP_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#ifndef PREGELSSSP_HPP_</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#define PREGELSSSP_HPP_</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;types.h&quot;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="edge_8hpp.html">edge.hpp</a>&quot;</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="PregelVertex_8hpp.html">PregelVertex.hpp</a>&quot;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="Message_8hpp.html">Message.hpp</a>&quot;</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="PregelCombiner_8hpp.html">PregelCombiner.hpp</a>&quot;</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div>
<div class="line"><a name="l00045"></a><span class="lineno"><a class="line" href="classDijksraInfo.html">   45</a></span>&#160;<span class="keyword">class </span><a class="code" href="classDijksraInfo.html">DijksraInfo</a></div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;{</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="classDijksraInfo.html#ad0f4c492550fcc8a0f960e508f698d04">   49</a></span>&#160;    uint32 <a class="code" href="classDijksraInfo.html#ad0f4c492550fcc8a0f960e508f698d04">parent</a>;</div>
<div class="line"><a name="l00051"></a><span class="lineno"><a class="line" href="classDijksraInfo.html#a57225980a19a31ea3131ff4e8d7c08cd">   51</a></span>&#160;    <span class="keywordtype">double</span> <a class="code" href="classDijksraInfo.html#a57225980a19a31ea3131ff4e8d7c08cd">distance</a>;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keywordtype">double</span> operator - (T &amp;ref){<span class="keywordflow">return</span> ref.distance-distance;}</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    <span class="keywordtype">double</span> operator * (T &amp;ref){<span class="keywordflow">return</span> ref.distance*distance;}</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="classDijksraInfo.html#a05874cccc8d0876351ceb79a00139195">   61</a></span>&#160;    <span class="keywordtype">double</span> operator + (T &amp;ref){<span class="keywordflow">return</span> ref.distance+distance;}</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div>
<div class="line"><a name="l00064"></a><span class="lineno"><a class="line" href="classDijksraInfo.html#a8f7c5d4a9719c56aacac3447e7302094">   64</a></span>&#160;    <span class="keywordtype">bool</span> operator &lt; (<a class="code" href="classDijksraInfo.html">DijksraInfo</a> &amp;ref){<span class="keywordflow">return</span> distance &lt; ref.<a class="code" href="classDijksraInfo.html#a57225980a19a31ea3131ff4e8d7c08cd">distance</a>;}</div>
<div class="line"><a name="l00066"></a><span class="lineno"><a class="line" href="classDijksraInfo.html#a1af678941fec8fde3f96f94c32e319b1">   66</a></span>&#160;    <span class="keywordtype">bool</span> operator &gt; (<a class="code" href="classDijksraInfo.html">DijksraInfo</a> &amp;ref){<span class="keywordflow">return</span> distance &gt; ref.<a class="code" href="classDijksraInfo.html#a57225980a19a31ea3131ff4e8d7c08cd">distance</a>;}</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="comment">//  bool operator &lt;= (DijksraInfo &amp;ref){return distance &lt;= ref.distance;}</span></div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="comment">//  bool operator &gt;= (DijksraInfo &amp;ref){return distance &gt;= ref.distance;}</span></div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;<span class="comment">//  bool operator == (DijksraInfo &amp;ref){return distance == ref.distance;}</span></div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <a class="code" href="classDijksraInfo.html">DijksraInfo</a> &amp; operator += (<a class="code" href="classDijksraInfo.html">DijksraInfo</a> &amp;ref){</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        distance += ref.<a class="code" href="classDijksraInfo.html#a57225980a19a31ea3131ff4e8d7c08cd">distance</a>;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        <span class="keywordflow">return</span> *<span class="keyword">this</span>;</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    }</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <span class="keywordtype">void</span> operator = (T distanceVal)</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    {</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        distance = distanceVal;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    }</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;};</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;ostream&amp; operator&lt;&lt;(ostream&amp; os, <span class="keyword">const</span> <a class="code" href="classDijksraInfo.html">DijksraInfo</a>&amp; x)</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;{</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    os &lt;&lt; <span class="stringliteral">&quot;(&quot;</span> &lt;&lt; x.<a class="code" href="classDijksraInfo.html#a57225980a19a31ea3131ff4e8d7c08cd">distance</a> &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; x.<a class="code" href="classDijksraInfo.html#ad0f4c492550fcc8a0f960e508f698d04">parent</a> &lt;&lt; <span class="stringliteral">&quot;)&quot;</span> ;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    <span class="keywordflow">return</span> os;</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;}</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> DataType = <span class="keywordtype">char</span>, <span class="keyword">typename</span> EdgeType = TIGLContainersEdgeBase&lt;u<span class="keywordtype">int</span>32&gt; &gt;</div>
<div class="line"><a name="l00103"></a><span class="lineno"><a class="line" href="classVertexP__SSSP.html">  103</a></span>&#160;<span class="keyword">class </span><a class="code" href="classVertexP__SSSP.html">VertexP_SSSP</a>:</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        <span class="keyword">public</span> <a class="code" href="classVertexP.html">VertexP</a>&lt;DataType, DijksraInfo, EdgeType, uint32, uint32, DblMessage&gt;</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;{</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classVertexP.html">VertexP&lt;DataType, double, TIGLContainersEdgeBase&lt;uint32&gt;</a>, uint32, uint32, <a class="code" href="classMessage.html">DblMessage</a>&gt;::MESSAGE_BUF_TYPE MESSAGE_BUF_TYPE;</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classVertexP.html">VertexP&lt;DataType, double, TIGLContainersEdgeBase&lt;uint32&gt;</a>, uint32, uint32, <a class="code" href="classMessage.html">DblMessage</a>&gt;::LOCAL_MESSAGE_BUF  LOCAL_MESSAGE_BUF;</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classVertexP.html">VertexP&lt;DataType, DijksraInfo, EdgeType, uint32, uint32, DblMessage&gt;::OUT_EDGE_ITERATOR</a> OUT_EDGE_ITERATOR;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00115"></a><span class="lineno"><a class="line" href="classVertexP__SSSP.html#a86aa1a26ed0840cfaef2afd7cbd1194d">  115</a></span>&#160;    <a class="code" href="classVertexP__SSSP.html#a86aa1a26ed0840cfaef2afd7cbd1194d">VertexP_SSSP</a>(uint32 key):</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        <a class="code" href="classVertexP.html">VertexP</a>&lt;DataType, <a class="code" href="classDijksraInfo.html">DijksraInfo</a>, EdgeType, uint32, uint32, <a class="code" href="classMessage.html">DblMessage</a>&gt;(key, false, false){}</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    ~<a class="code" href="classVertexP__SSSP.html">VertexP_SSSP</a>(){}</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    uint32 compute(MESSAGE_BUF_TYPE * pIn, LOCAL_MESSAGE_BUF * pOut, uint32 numMessages)</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    {</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;        <span class="comment">//uint32 t1 = (this-&gt;aggregateInfoPtr-&gt;countSS-1)%AGGREGATE_HISTORY;</span></div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        uint32 t = this-&gt;aggregateInfoPtr-&gt;getNumSS();</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        <span class="keywordflow">if</span>(numMessages &gt; 1)</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;            cout&lt;&lt;<span class="stringliteral">&quot;!!! Warning PregelSSSP compute: numMessages(&quot;</span> &lt;&lt; this-&gt;getId() &lt;&lt; <span class="stringliteral">&quot;) = &quot;</span> &lt;&lt; numMessages &lt;&lt; endl;<span class="comment">//cout&lt;&lt;&quot;!!! Warning : numMessages(&quot; &lt;&lt; this-&gt;getId() &lt;&lt; &quot;) = &quot; &lt;&lt; pIn-&gt;size() &lt;&lt; endl;</span></div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        <span class="keywordflow">if</span>(numMessages &gt; pIn-&gt;size())</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;            cout&lt;&lt;<span class="stringliteral">&quot;!!! Warning PregelSSSP compute: numMessages is bigger than buffer size&quot;</span>&lt;&lt; endl;</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;        <span class="comment">// computing the new rank from the input messages</span></div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;        vector&lt;DblMessage&gt;::iterator itm = pIn-&gt;begin();</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;        <span class="keywordtype">double</span> newDistance = itm-&gt;getContent();</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;        <span class="keywordtype">double</span> newParent = itm-&gt;getSender();</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        <span class="keywordflow">if</span>(numMessages &gt; 1)</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        {</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;            <span class="keywordflow">for</span>(uint32 loopCount = 0; loopCount &lt; numMessages; loopCount++)<span class="comment">//itm != pIn-&gt;end(); ++itm)</span></div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;            {</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;                ++itm;</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;                <span class="keywordflow">if</span>(newDistance &gt; itm-&gt;getContent())</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;                {</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;                    newDistance = itm-&gt;getContent();</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;                    newParent = itm-&gt;getSender();</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;                }</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;            }</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        }</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;        uint32 numOutMessages = 0;</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        <span class="keywordflow">if</span>(newDistance &lt; this-&gt;algData.distance) <span class="comment">// or visited before but we have bettern score</span></div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        {</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;            this-&gt;algData.distance = newDistance;</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;            this-&gt;algData.parent = newParent;</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;            <span class="comment">// now sending message to all children</span></div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;            <span class="keywordflow">for</span>(OUT_EDGE_ITERATOR ite = this-&gt;get_out_edge_iterator();</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;                    ite != this-&gt;get_end_out_edge_iterator(); ++ite)</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;            {</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;                uint32 dst = ite-&gt;getNbr();</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;                <span class="keywordflow">if</span>(dst == this-&gt;<span class="keywordtype">id</span>)</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;                    <span class="keywordflow">continue</span>; <span class="comment">// ignoring self reference</span></div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;                <span class="keywordtype">double</span> messageVal = ite-&gt;hasVal()?</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;                                    newDistance+ite-&gt;getData():</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;                                    newDistance+1;</div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;                <a class="code" href="classMessage.html">DblMessage</a> newMessage(this-&gt;<span class="keywordtype">id</span>, dst, messageVal);</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;                pOut-&gt;push_back(newMessage);</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;                numOutMessages++;</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;            }</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        }</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        <span class="keywordflow">if</span>(t &gt; 1 &amp;&amp; this-&gt;algData.distance &lt;= (this-&gt;aggregateInfoPtr-&gt;getPastMinActiveAlgData()).distance)</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        {</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;            this-&gt;vote_to_halt();</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        }</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;<span class="comment">//      if(t == 1 &amp;&amp; numMessages &gt; 0)</span></div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;<span class="comment">//      {</span></div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;<span class="comment">//#pragma omp critical</span></div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;<span class="comment">//          cout&lt;&lt;&quot;id &quot; &lt;&lt; this-&gt;id&lt;&lt; &quot;: &quot; &lt;&lt; &quot;numMes = &quot; &lt;&lt; numMessages &lt;&lt; &quot;, dist = &quot; &lt;&lt; this-&gt;algData.distance &lt;&lt; endl;</span></div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;<span class="comment">//      }</span></div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;        <span class="keywordflow">return</span> numOutMessages;</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    }</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;</div>
<div class="line"><a name="l00186"></a><span class="lineno"><a class="line" href="classVertexP__SSSP.html#a0534672599ca258e3c78e97a95a23045">  186</a></span>&#160;    uint32 <a class="code" href="classVertexP__SSSP.html#a0534672599ca258e3c78e97a95a23045">init</a>(uint32 * src, LOCAL_MESSAGE_BUF * pOut)</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    {</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;        <span class="keywordflow">if</span> (this-&gt;<span class="keywordtype">id</span> == *src)</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;        {</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;            this-&gt;algData.distance = 0;</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;            this-&gt;algData.parent = *src;</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;            <span class="comment">// now sending messages to children nodes to the act</span></div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;            uint32 numOutMessages = 0;</div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;            <span class="keywordflow">for</span>(OUT_EDGE_ITERATOR ite = this-&gt;get_out_edge_iterator();</div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;                    ite != this-&gt;get_end_out_edge_iterator(); ++ite)</div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;            {</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;                uint32 dst = ite-&gt;getNbr();</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;                <span class="keywordflow">if</span>(dst == this-&gt;<span class="keywordtype">id</span>)</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;                    <span class="keywordflow">continue</span>; <span class="comment">// ignoring self reference</span></div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;                <span class="keywordtype">double</span> messageVal = ite-&gt;hasVal()? ite-&gt;getData():1;</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;                <a class="code" href="classMessage.html">DblMessage</a> newMessage(this-&gt;<span class="keywordtype">id</span>, dst, messageVal);</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;                pOut-&gt;push_back(newMessage);</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;                numOutMessages++;</div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;            }</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;</div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;            this-&gt;vote_to_halt();</div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;            <span class="keywordflow">return</span> numOutMessages;</div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;        }</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;        <span class="keywordflow">else</span></div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;        {</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;            this-&gt;algData.distance = BIG_DBL_NUMBER;</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;            this-&gt;algData.parent = UNDEFINED_NODE;</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;            this-&gt;activate();</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;            <span class="keywordflow">return</span> 0;</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;        }</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;    }</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;};</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00234"></a><span class="lineno"><a class="line" href="classPregelCombinerSSSP.html">  234</a></span>&#160;<span class="comment"></span><span class="keyword">class </span><a class="code" href="classPregelCombinerSSSP.html">PregelCombinerSSSP</a>:</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;        <span class="keyword">public</span> <a class="code" href="classPregelCombiner.html">PregelCombiner</a>&lt;DblMessage&gt;</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;{</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;    <span class="keyword">typedef</span> <span class="keyword">typename</span> vector&lt;DblMessage&gt;::iterator   MESSAGE_ITERATOR;</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;    <a class="code" href="classPregelCombinerSSSP.html">PregelCombinerSSSP</a>(){}</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;    ~<a class="code" href="classPregelCombinerSSSP.html">PregelCombinerSSSP</a>(){}</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00246"></a><span class="lineno"><a class="line" href="classPregelCombinerSSSP.html#ad4a514880a7b81cccd697789469e66a7">  246</a></span>&#160;    uint32 <a class="code" href="classPregelCombinerSSSP.html#ad4a514880a7b81cccd697789469e66a7">combineMessages</a>(MESSAGE_ITERATOR itIn, uint32 numMessages, MESSAGE_ITERATOR itOut)</div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;    {</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;         <span class="keywordflow">return</span> minCombineMessages(itIn, numMessages, itOut);</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;    }</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;};</div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* PREGELDIJKSTRA_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="Message_8hpp_html"><div class="ttname"><a href="Message_8hpp.html">Message.hpp</a></div><div class="ttdoc">contains core Massage container class for Pregel </div></div>
<div class="ttc" id="PregelCombiner_8hpp_html"><div class="ttname"><a href="PregelCombiner_8hpp.html">PregelCombiner.hpp</a></div><div class="ttdoc">contains the definition of the combiner class </div></div>
<div class="ttc" id="classMessage_html"><div class="ttname"><a href="classMessage.html">Message</a></div><div class="ttdef"><b>Definition:</b> Message.hpp:28</div></div>
<div class="ttc" id="classDijksraInfo_html_ad0f4c492550fcc8a0f960e508f698d04"><div class="ttname"><a href="classDijksraInfo.html#ad0f4c492550fcc8a0f960e508f698d04">DijksraInfo::parent</a></div><div class="ttdeci">uint32 parent</div><div class="ttdef"><b>Definition:</b> pregelSSSP.hpp:49</div></div>
<div class="ttc" id="classPregelCombinerSSSP_html_ad4a514880a7b81cccd697789469e66a7"><div class="ttname"><a href="classPregelCombinerSSSP.html#ad4a514880a7b81cccd697789469e66a7">PregelCombinerSSSP::combineMessages</a></div><div class="ttdeci">uint32 combineMessages(MESSAGE_ITERATOR itIn, uint32 numMessages, MESSAGE_ITERATOR itOut)</div><div class="ttdoc">customized combine function that calls the generic minimum combine </div><div class="ttdef"><b>Definition:</b> pregelSSSP.hpp:246</div></div>
<div class="ttc" id="edge_8hpp_html"><div class="ttname"><a href="edge_8hpp.html">edge.hpp</a></div><div class="ttdoc">contains core edge classes </div></div>
<div class="ttc" id="classPregelCombinerSSSP_html"><div class="ttname"><a href="classPregelCombinerSSSP.html">PregelCombinerSSSP</a></div><div class="ttdoc">Combiner class for the Single Source Shortest Path using the Dijkstra Algorithm. it uses the min comb...</div><div class="ttdef"><b>Definition:</b> pregelSSSP.hpp:234</div></div>
<div class="ttc" id="PregelVertex_8hpp_html"><div class="ttname"><a href="PregelVertex_8hpp.html">PregelVertex.hpp</a></div><div class="ttdoc">: core vertex class definitions for pregel engine </div></div>
<div class="ttc" id="classPregelCombiner_html"><div class="ttname"><a href="classPregelCombiner.html">PregelCombiner</a></div><div class="ttdef"><b>Definition:</b> PregelCombiner.hpp:29</div></div>
<div class="ttc" id="classVertexP__SSSP_html"><div class="ttname"><a href="classVertexP__SSSP.html">VertexP_SSSP</a></div><div class="ttdoc">Customized Pregel Vertex class for the Single Source Shortest Path using the Dijkstra Algorithm...</div><div class="ttdef"><b>Definition:</b> pregelSSSP.hpp:103</div></div>
<div class="ttc" id="classDijksraInfo_html"><div class="ttname"><a href="classDijksraInfo.html">DijksraInfo</a></div><div class="ttdoc">Parameters of the algorithm field in the Dijkstra algorithm it contains customized definition of the ...</div><div class="ttdef"><b>Definition:</b> pregelSSSP.hpp:45</div></div>
<div class="ttc" id="classVertexP__SSSP_html_a0534672599ca258e3c78e97a95a23045"><div class="ttname"><a href="classVertexP__SSSP.html#a0534672599ca258e3c78e97a95a23045">VertexP_SSSP::init</a></div><div class="ttdeci">uint32 init(uint32 *src, LOCAL_MESSAGE_BUF *pOut)</div><div class="ttdoc">init procedure for the Dijkstra algorithm </div><div class="ttdef"><b>Definition:</b> pregelSSSP.hpp:186</div></div>
<div class="ttc" id="classVertexP_html"><div class="ttname"><a href="classVertexP.html">VertexP</a></div><div class="ttdoc">core vertex class for Pregel Engine (with only output edge buffer). It inherits the core vertex class...</div><div class="ttdef"><b>Definition:</b> PregelVertex.hpp:35</div></div>
<div class="ttc" id="classVertexP__SSSP_html_a86aa1a26ed0840cfaef2afd7cbd1194d"><div class="ttname"><a href="classVertexP__SSSP.html#a86aa1a26ed0840cfaef2afd7cbd1194d">VertexP_SSSP::VertexP_SSSP</a></div><div class="ttdeci">VertexP_SSSP(uint32 key)</div><div class="ttdoc">constructor: disable vertex processing in the absence of messages </div><div class="ttdef"><b>Definition:</b> pregelSSSP.hpp:115</div></div>
<div class="ttc" id="classDijksraInfo_html_a57225980a19a31ea3131ff4e8d7c08cd"><div class="ttname"><a href="classDijksraInfo.html#a57225980a19a31ea3131ff4e8d7c08cd">DijksraInfo::distance</a></div><div class="ttdeci">double distance</div><div class="ttdef"><b>Definition:</b> pregelSSSP.hpp:51</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Oct 3 2014 16:46:36 for TIPregelGraphLibrary by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
